package com.example.bcryptpassworden;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.bcryptpassworden.domain.Employees;
import com.example.bcryptpassworden.domain.User;
import com.example.bcryptpassworden.mapper.EmployeesMapper;
import com.example.bcryptpassworden.mapper.UserMapper;
import com.example.bcryptpassworden.service.impl.EmployeesServiceImpl;
import com.example.bcryptpassworden.service.impl.UserServiceImpl;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.logging.log4j.util.Base64Util;
import org.junit.jupiter.api.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.util.DigestUtils;

import java.util.Base64;
import java.util.List;
import java.util.stream.Collectors;

/**
 *
 */
@RunWith(SpringRunner.class)
@SpringBootTest
class BCryptPasswordEnApplicationTests {

    @Autowired
    private UserMapper userMapper;

    @Autowired
    private UserServiceImpl userService;

    @Autowired
    private EmployeesMapper employeesMapper;

    @Autowired
    private EmployeesServiceImpl employeesService;



    @Test
    public void test1(){
        String pwd ="123456";
        String s = DigestUtils.md5DigestAsHex(pwd.getBytes());
        System.out.println(s);
    }



    @Test
    public void base6(){
        String str = "599691";

        System.out.println("编码后的字符串为：");
        String encode = Base64Util.encode(str);
        System.out.println(Base64Util.encode(str));

        byte[] decode = Base64.getDecoder().decode(encode);
        String decodedString = new String(decode);
        System.out.println("解密后的字符串");
        System.out.println(decodedString);

        BCryptPasswordEncoder bCryptPasswordEncoder = new BCryptPasswordEncoder();
        String encode1 = bCryptPasswordEncoder.encode("123456");
        String encode2 = bCryptPasswordEncoder.encode("123456");
        String encode3 = bCryptPasswordEncoder.encode("123456");
        String encode4 = bCryptPasswordEncoder.encode("123456");
        String encode5 = bCryptPasswordEncoder.encode("123456");
        System.out.println(encode1);
        System.out.println(encode2);
        System.out.println(encode3);
        System.out.println(encode4);
        System.out.println(encode5);

        boolean matches = bCryptPasswordEncoder.matches( "123456",encode4);

        System.out.println(matches);


    }

    public String decode(String basecode){

        byte[] decode = Base64.getDecoder().decode(basecode);

        String decodedString = new String(decode);

        return decodedString;
    }


    public String BrcEncoder(String rawPassword){

        BCryptPasswordEncoder bCryptPasswordEncoder = new BCryptPasswordEncoder();

        String BcrPassword = bCryptPasswordEncoder.encode(rawPassword);

        return BcrPassword;

    }

    /**
     * 工具类: base64转 Bcrypt
     */
    public String Base64ToBcr(String rawPassword){

        //base64 转明文
        byte[] password = Base64.getDecoder().decode(rawPassword);

        String passwordString = new String(password);

        //明文转bcr
        BCryptPasswordEncoder bCryptPasswordEncoder = new BCryptPasswordEncoder();

        String BcrPassword = bCryptPasswordEncoder.encode(passwordString);

        return BcrPassword;

    }


    @Test
    public void findAll() {

        // List<Person> personList = new ArrayList<Person>();
        // personList.add(new Person("Tom", 8900, 23, "male", "New York"));
        // personList.add(new Person("Jack", 7000, 25, "male", "Washington"));
        // personList.add(new Person("Lily", 7800, 21, "female", "Washington"));
        // personList.add(new Person("Anni", 8200, 24, "female", "New York"));
        // personList.add(new Person("Owen", 9500, 25, "male", "New York"));
        // personList.add(new Person("Alisa", 7900, 26, "female", "New York"));
        // //
        // // // 不改变原来员工集合的方式
        // List<Person> personListNew = personList.stream().map(person -> {
        //     Person personNew = new Person(person.getName(), 0, 0, null, null);
        //     personNew.setSalary(person.getSalary() + 10000);
        //     return personNew;
        // }).collect(Collectors.toList());
        //
        // personListNew.forEach(System.out::println);
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        QueryWrapper<User> last = queryWrapper.last("limit 1");

        List<User> rawUsers = userMapper.selectList(last);

        List<User> userListNew = rawUsers.stream().map(user -> {
            String rawPassword = user.getPassword();
            System.out.println(rawPassword);

            String base64ToBcr = Base64ToBcr(rawPassword);
            User BrcUser = new User();

            BrcUser.setPassword(base64ToBcr);
            return BrcUser;
        }).collect(Collectors.toList());
        userListNew.forEach(System.out::println);
    //  批量更新


    }


    @Test
    public void batchUpdate(){
        List<Employees> RawEmployees = employeesMapper.selectList(null);

        for (Employees employee : RawEmployees) {

            employee.setFirstName("test");

        }
        boolean updateBatchById = employeesService.updateBatchById(RawEmployees);

        if(updateBatchById){
            List<Employees> employees = employeesMapper.selectList(null);
            employees.forEach(System.out::println);
        }

        RawEmployees.forEach(System.out::println);

    }


    /**
     * springboot 工程
     * 1.整合mybatis-plus
     * 2查询出集合列表
     * 3.更换密码
     * 4.批量更新
     *
     */

    @Test
    public void batchBaseToBcr(){
        List<User> rawUserList = userMapper.selectList(null);

        rawUserList.stream().peek(user -> {
            String password = user.getPassword();

            String base64ToBcr = Base64ToBcr(password);
            user.setPassword(base64ToBcr);
        }).collect(Collectors.toList());

        userService.updateBatchById(rawUserList);

        rawUserList.forEach(System.out::println);




    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    class Person {
        private String name;  // 姓名
        private int salary; // 薪资
        private int age; // 年龄
        private String sex; //性别
        private String area;  // 地区


        // 省略了get和set，请自行添加

    }


}
